<template>
	<v-form ref="formPersonalData" v-model="isValid">
		<v-card>
			<v-card-text>
				<!-- Fila de datos oficiales -->
				<v-row>
					<v-col cols="12" sm="6">
						<v-text-field
							id="curp"
							prepend-icon="fas fa-id-card"
							label="CURP"
							:rules="rulesCURP"
							outlined
							v-model="curp"
							required
						/>
					</v-col>
					<v-col cols="12" sm="6">
						<v-text-field
							prepend-icon="fas fa-at"
							label="Correo electrónico"
							:rules="rulesEmail"
							outlined
							v-model="email"
							required
						/>
					</v-col>
				</v-row>
				<!-- Fila de nombres -->
				<v-row>
					<v-col cols="12" sm="4">
						<v-text-field
							id="cap"
							prepend-icon="fas fa-address-card"
							label="Nombre"
							:rules="ruleNames"
							outlined
							v-model.trim="personalData.name"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<v-text-field
							id="cap"
							prepend-icon="fas fa-address-card"
							label="Apellido paterno"
							:rules="ruleNames"
							outlined
							v-model.trim="personalData.fstSurname"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<v-text-field
							id="cap"
							prepend-icon="fas fa-address-card"
							label="Apellido materno"
							:rules="ruleNames"
							outlined
							v-model.trim="personalData.sndSurname"
							required
						/>
					</v-col>
				</v-row>
				<!-- fila de edad y genero -->
				<v-row justify="center">
					<v-col cols="12" sm="3">
						<v-text-field
							prepend-icon="fas fa-sort-numeric-up"
							label="Edad"
							:rules="rulesAge"
							outlined
							min="0"
							type="number"
							suffix="años"
							v-model="personalData.age"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<p slot="label" class="headline">Selecciona un género</p>
						<v-radio-group
							v-model="personalData.gender"
							mandatory
							row
							prepend-icon="fa-venus-mars"
							:rules="ruleRequired"
						>
							<v-radio label="Hombre" value="Hombre" color="blue" />
							<v-radio label="Mujer" value="Mujer" color="blue" />
						</v-radio-group>
					</v-col>
					<v-col cols="12" sm="4">
						<p slot="label" class="headline">¿Perteneces a un grupo étnico?</p>
						<v-radio-group
							v-model="ethnicGroup"
							mandatory
							row
							prepend-icon="fa-user-friends"
							:rules="ruleRequired"
						>
							<v-radio label="Si" value="Si" color="blue" />
							<v-radio label="No" value="No" color="blue" />
						</v-radio-group>
					</v-col>
				</v-row>
			</v-card-text>
			<v-card-actions>
				<v-row justify="center" justify-sm="start">
					<v-col cols="12" sm="3">
						<v-btn
							:disabled="!isValid || !saved"
							:loading="loading"
							block
							outlined
							color="green"
							@click="save"
						>
							Guardar
							<template v-slot:loader>
								<span>Guardando...</span>
							</template>
						</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn :disabled="saved" block outlined color="blue" @click="next">Siguiente</v-btn>
					</v-col>
				</v-row>
			</v-card-actions>
		</v-card>
	</v-form>
</template>

<script>
import EventBus from "../../bus";
import { mapState, mapMutations, mapActions } from "vuex";
import gql from "graphql-tag";

export default {
	name: "FormPersonalData",
	data: () => ({
		isValid: true,
		saved: true,
		loading: false,
		ethnicGroup: "No",
		curp: "",
		email: "",
		personalData: {
			name: "",
			fstSurname: "",
			sndSurname: "",
			age: "",
			gender: "Hombre",
			ethnicGroup: null
		},
		ruleRequired: [value => !!value || "Campo requerido"],
		ruleNames: [
			value => !!value || "Campo requerido",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'"1234567890,<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo permitidas letras";
			}
		],
		rulesAge: [
			value => !!value || "Campo requerido",
			value => (value >= 15 && value <= 50) || "Tienes que ser estudiante"
		],
		rulesCURP: [
			value => !!value || "Campo requerido",
			value =>
				(value || "").length === 18 || "18 carácteres obligatorios",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'",<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo letras y números";
			}
		],
		rulesEmail: [
			value => !!value || "Campo requerido",
			value => {
				const pattern = /^\w+([\.-]?\w+)*@\w+(\.com||\.com\.mx||\.mx||\.es||\.uaz||\.edu\.mx||\.utzac\.edu\.mx)+$/;
				return pattern.test(value) || "Correo electrónico inválido";
			}
		]
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),
		...mapActions(["savePersonalData"]),
		// Obtiene la curp y el email del usuario
		async getData() {
			this.saveUserData();
			try {
				const data = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								email
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				this.email = data.data.findStudent.email;
				this.curp = this.userData.curp;
			} catch (error) {}
		},
		// primera letra mayúscula
		capitalLetter(name){
			name = name.split(" ");

    		for (var i = 0, x = name.length; i < x; i++) {
    		    name[i] = name[i][0].toUpperCase() + name[i].substr(1);
    		}

    		return name.join(" ");
		},
		next() {
			EventBus.$emit("nextStep");
		},
		// LLama la accion que guarda los datos personales
		save() {
			this.personalData.name = this.capitalLetter(this.personalData.name);
			this.personalData.fstSurname = this.capitalLetter(this.personalData.fstSurname);
			this.personalData.sndSurname = this.capitalLetter(this.personalData.sndSurname);
			this.ethnicGroup === "Si"
				? (this.personalData.ethnicGroup = true)
				: (this.personalData.ethnicGroup = false);
			this.personalData.age = parseInt(this.personalData.age, 10);
			this.savePersonalData(this.personalData);
			this.loading = true;
		}
	},
	mounted() {
		// Habilita el boton de siguiente
		EventBus.$on("personalDataSaved", () => {
			setTimeout(() => {
				this.loading = false;
				this.saved = false;
			}, 1500);
		});
	},
	created() {
		this.getData();
	}
};
</script>

<style scope>
#curp {
	text-transform: uppercase;
}
#cap{
	text-transform: capitalize;
}
</style>